xref: /openbmc/linux/scripts/kconfig/Makefile (revision 2c363576)
1# SPDX-License-Identifier: GPL-2.0
2# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
6PHONY += xconfig gconfig menuconfig config syncconfig update-po-config \
7	localmodconfig localyesconfig
8
9ifdef KBUILD_KCONFIG
10Kconfig := $(KBUILD_KCONFIG)
11else
12Kconfig := Kconfig
13endif
14
15ifeq ($(quiet),silent_)
16silent := -s
17endif
18
19# We need this, in case the user has it in its environment
20unexport CONFIG_
21
22xconfig: $(obj)/qconf
23	$< $(silent) $(Kconfig)
24
25gconfig: $(obj)/gconf
26	$< $(silent) $(Kconfig)
27
28menuconfig: $(obj)/mconf
29	$< $(silent) $(Kconfig)
30
31config: $(obj)/conf
32	$< $(silent) --oldaskconfig $(Kconfig)
33
34nconfig: $(obj)/nconf
35	$< $(silent) $(Kconfig)
36
37# This has become an internal implementation detail and is now deprecated
38# for external use.
39syncconfig: $(obj)/conf
40	$(Q)mkdir -p include/config include/generated
41	$< $(silent) --$@ $(Kconfig)
42
43localyesconfig localmodconfig: $(obj)/conf
44	$(Q)mkdir -p include/config include/generated
45	$(Q)perl $(srctree)/$(src)/streamline_config.pl --$@ $(srctree) $(Kconfig) > .tmp.config
46	$(Q)if [ -f .config ]; then 					\
47			cmp -s .tmp.config .config ||			\
48			(mv -f .config .config.old.1;			\
49			 mv -f .tmp.config .config;			\
50			 $< $(silent) --oldconfig $(Kconfig);		\
51			 mv -f .config.old.1 .config.old)		\
52	else								\
53			mv -f .tmp.config .config;			\
54			$< $(silent) --oldconfig $(Kconfig);		\
55	fi
56	$(Q)rm -f .tmp.config
57
58# Create new linux.pot file
59# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
60update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
61	$(Q)$(kecho) "  GEN     config.pot"
62	$(Q)xgettext --default-domain=linux                         \
63	    --add-comments --keyword=_ --keyword=N_                 \
64	    --from-code=UTF-8                                       \
65	    --files-from=$(srctree)/scripts/kconfig/POTFILES.in     \
66	    --directory=$(srctree) --directory=$(objtree)           \
67	    --output $(obj)/config.pot
68	$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
69	$(Q)(for i in `ls $(srctree)/arch/*/Kconfig      \
70	    $(srctree)/arch/*/um/Kconfig`;               \
71	    do                                           \
72		$(kecho) "  GEN     $$i";                    \
73		$(obj)/kxgettext $$i                     \
74		     >> $(obj)/config.pot;               \
75	    done )
76	$(Q)$(kecho) "  GEN     linux.pot"
77	$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
78	    --output $(obj)/linux.pot
79	$(Q)rm -f $(obj)/config.pot
80
81# These targets map 1:1 to the commandline options of 'conf'
82simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
83	alldefconfig randconfig listnewconfig olddefconfig
84PHONY += $(simple-targets)
85
86$(simple-targets): $(obj)/conf
87	$< $(silent) --$@ $(Kconfig)
88
89PHONY += oldnoconfig silentoldconfig savedefconfig defconfig
90
91# oldnoconfig is an alias of olddefconfig, because people already are dependent
92# on its behavior (sets new symbols to their default value but not 'n') with the
93# counter-intuitive name.
94oldnoconfig: olddefconfig
95	@echo "  WARNING: \"oldnoconfig\" target will be removed after Linux 4.19"
96	@echo "            Please use \"olddefconfig\" instead, which is an alias."
97
98# We do not expect manual invokcation of "silentoldcofig" (or "syncconfig").
99silentoldconfig: syncconfig
100	@echo "  WARNING: \"silentoldconfig\" has been renamed to \"syncconfig\""
101	@echo "            and is now an internal implementation detail."
102	@echo "            What you want is probably \"oldconfig\"."
103	@echo "            \"silentoldconfig\" will be removed after Linux 4.19"
104
105savedefconfig: $(obj)/conf
106	$< $(silent) --$@=defconfig $(Kconfig)
107
108defconfig: $(obj)/conf
109ifeq ($(KBUILD_DEFCONFIG),)
110	$< $(silent) --defconfig $(Kconfig)
111else
112ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
113	@$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
114	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
115else
116	@$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
117	$(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
118endif
119endif
120
121%_defconfig: $(obj)/conf
122	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
123
124configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
125
126%.config: $(obj)/conf
127	$(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
128	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
129	+$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
130
131PHONY += kvmconfig
132kvmconfig: kvm_guest.config
133	@:
134
135PHONY += xenconfig
136xenconfig: xen.config
137	@:
138
139PHONY += tinyconfig
140tinyconfig:
141	$(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
142
143# CHECK: -o cache_dir=<path> working?
144PHONY += testconfig
145testconfig: $(obj)/conf
146	$(PYTHON3) -B -m pytest $(srctree)/$(src)/tests \
147	-o cache_dir=$(abspath $(obj)/tests/.cache) \
148	$(if $(findstring 1,$(KBUILD_VERBOSE)),--capture=no)
149clean-dirs += tests/.cache
150
151# Help text used by make help
152help:
153	@echo  '  config	  - Update current config utilising a line-oriented program'
154	@echo  '  nconfig         - Update current config utilising a ncurses menu based'
155	@echo  '                    program'
156	@echo  '  menuconfig	  - Update current config utilising a menu based program'
157	@echo  '  xconfig	  - Update current config utilising a Qt based front-end'
158	@echo  '  gconfig	  - Update current config utilising a GTK+ based front-end'
159	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
160	@echo  '  localmodconfig  - Update current config disabling modules not loaded'
161	@echo  '  localyesconfig  - Update current config converting local mods to core'
162	@echo  '  defconfig	  - New config with default from ARCH supplied defconfig'
163	@echo  '  savedefconfig   - Save current config as ./defconfig (minimal config)'
164	@echo  '  allnoconfig	  - New config where all options are answered with no'
165	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
166	@echo  '  allmodconfig	  - New config selecting modules when possible'
167	@echo  '  alldefconfig    - New config with all symbols set to default'
168	@echo  '  randconfig	  - New config with random answer to all options'
169	@echo  '  listnewconfig   - List new options'
170	@echo  '  olddefconfig	  - Same as oldconfig but sets new symbols to their'
171	@echo  '                    default value without prompting'
172	@echo  '  kvmconfig	  - Enable additional options for kvm guest kernel support'
173	@echo  '  xenconfig       - Enable additional options for xen dom0 and guest kernel support'
174	@echo  '  tinyconfig	  - Configure the tiniest possible kernel'
175
176# lxdialog stuff
177check-lxdialog  := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
178
179# Use recursively expanded variables so we do not call gcc unless
180# we really need to do so. (Do not call gcc as part of make mrproper)
181HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
182                    -DLOCALE
183
184# ===========================================================================
185# Shared Makefile for the various kconfig executables:
186# conf:	  Used for defconfig, oldconfig and related targets
187# nconf:  Used for the nconfig target.
188#         Utilizes ncurses
189# mconf:  Used for the menuconfig target
190#         Utilizes the lxdialog package
191# qconf:  Used for the xconfig target
192#         Based on Qt which needs to be installed to compile it
193# gconf:  Used for the gconfig target
194#         Based on GTK+ which needs to be installed to compile it
195# object files used by all kconfig flavours
196
197lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
198lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
199
200conf-objs	:= conf.o  zconf.tab.o
201mconf-objs     := mconf.o zconf.tab.o $(lxdialog)
202nconf-objs     := nconf.o zconf.tab.o nconf.gui.o
203kxgettext-objs	:= kxgettext.o zconf.tab.o
204qconf-cxxobjs	:= qconf.o
205qconf-objs	:= zconf.tab.o
206gconf-objs	:= gconf.o zconf.tab.o
207
208hostprogs-y := conf nconf mconf kxgettext qconf gconf
209
210targets		+= zconf.lex.c
211clean-files	:= qconf.moc .tmp_qtcheck .tmp_gtkcheck
212clean-files	+= gconf.glade.h
213clean-files     += config.pot linux.pot
214
215# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
216PHONY += $(obj)/dochecklxdialog
217$(addprefix $(obj)/, mconf.o $(lxdialog)): $(obj)/dochecklxdialog
218$(obj)/dochecklxdialog:
219	$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
220
221always := dochecklxdialog
222
223# Add environment specific flags
224HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
225HOST_EXTRACXXFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCXX) $(HOSTCXXFLAGS))
226
227# generated files seem to need this to find local include files
228HOSTCFLAGS_zconf.lex.o	:= -I$(src)
229HOSTCFLAGS_zconf.tab.o	:= -I$(src)
230
231HOSTLOADLIBES_qconf	= $(KC_QT_LIBS)
232HOSTCXXFLAGS_qconf.o	= $(KC_QT_CFLAGS)
233
234HOSTLOADLIBES_gconf	= `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
235HOSTCFLAGS_gconf.o	= `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
236                          -Wno-missing-prototypes
237
238HOSTLOADLIBES_mconf   = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
239
240HOSTLOADLIBES_nconf	= $(shell \
241				pkg-config --libs menuw panelw ncursesw 2>/dev/null \
242				|| pkg-config --libs menu panel ncurses 2>/dev/null \
243				|| echo "-lmenu -lpanel -lncurses"  )
244$(obj)/qconf.o: $(obj)/.tmp_qtcheck
245
246ifeq ($(MAKECMDGOALS),xconfig)
247$(obj)/.tmp_qtcheck: $(src)/Makefile
248-include $(obj)/.tmp_qtcheck
249
250# Qt needs some extra effort...
251$(obj)/.tmp_qtcheck:
252	@set -e; $(kecho) "  CHECK   qt"; \
253	if pkg-config --exists Qt5Core; then \
254	    cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
255	    libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
256	    moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
257	elif pkg-config --exists QtCore; then \
258	    cflags=`pkg-config --cflags QtCore QtGui`; \
259	    libs=`pkg-config --libs QtCore QtGui`; \
260	    moc=`pkg-config --variable=moc_location QtCore`; \
261	else \
262	    echo >&2 "*"; \
263	    echo >&2 "* Could not find Qt via pkg-config."; \
264	    echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
265	    echo >&2 "*"; \
266	    exit 1; \
267	fi; \
268	echo "KC_QT_CFLAGS=$$cflags" > $@; \
269	echo "KC_QT_LIBS=$$libs" >> $@; \
270	echo "KC_QT_MOC=$$moc" >> $@
271endif
272
273$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
274
275ifeq ($(MAKECMDGOALS),gconfig)
276-include $(obj)/.tmp_gtkcheck
277
278# GTK+ needs some extra effort, too...
279$(obj)/.tmp_gtkcheck:
280	@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then		\
281		if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then			\
282			touch $@;								\
283		else									\
284			echo >&2 "*"; 							\
285			echo >&2 "* GTK+ is present but version >= 2.0.0 is required.";	\
286			echo >&2 "*";							\
287			false;								\
288		fi									\
289	else										\
290		echo >&2 "*"; 								\
291		echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; 	\
292		echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; 	\
293		echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; 		\
294		echo >&2 "*"; 								\
295		false;									\
296	fi
297endif
298
299$(obj)/zconf.tab.o: $(obj)/zconf.lex.c
300
301$(obj)/qconf.o: $(obj)/qconf.moc
302
303quiet_cmd_moc = MOC     $@
304      cmd_moc = $(KC_QT_MOC) -i $< -o $@
305
306$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
307	$(call cmd,moc)
308
309# Extract gconf menu items for i18n support
310$(obj)/gconf.glade.h: $(obj)/gconf.glade
311	$(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
312	$(obj)/gconf.glade
313